// ArtSoft corp.

inline engine_init() {
	vblank_wait()
	lda #0
	sta PPU.CNT1 // Turn Off video
	sta scroll_X
	sta scroll_Y

	init_horiz_level()

	assign(PPU.CNT1, #CR_BACKVISIBLE|CR_BACKNOCLIP) // Turn On video
}

/*************************************
 * A указатель на [macro] tile
 ************************************/
inline get_level_tile_a(dest, p_tiles, amount) {
	sta dest
	lda #0
	sta dest+1
	asl_16(dest, #amount)
	add_16_16(dest, p_tiles)
}

/*************************************
 * plevel указатель на линию уровня
 ************************************/
function init_sreen_line() {
	assign(yOffs, #lo(screan_attr))
	assign(sizeY, #LEVEL_HEIGHT)
	assign(xOffs, #lo(screan_line))
	do {
		ldx #0
		lda [plevel, x]
		get_level_tile_a(paddr, level_macro_blocks, macro_block_amount)
		assign(sizeX, #4)
		do {
			ldx #0
			lda [paddr, x]
			get_level_tile_a(pstr, level_tiles, tile_block_amount)
			ldy #3
			do {
				lda [pstr], y
				ldx xOffs
				sta screan_line, x
				inc xOffs
				dey
			} while (not minus)
			inc paddr
			dec sizeX
		} while (not zero)
		// color to attr table
		ldx #0
		lda [paddr, x]
		ldx yOffs
		sta screan_attr, x
		inc yOffs
		//inc paddr
		inc_16(plevel)
		dec sizeY
	} while (not zero)
}

/*function init_horiz_level() {
	assign(PPU.CNT0, #CR_ADDRINC32) // Vertical vram addressing
	assign(sizeX, level_lenght)
	assign_16i(pstr, level_data)
	assign_16i(paddr, NAME_TABLE_0_ADDRESS)

	ldy #0
	do {
		ldx #LEVEL_HEIGHT
		vram_set_address(paddr)
		do {
			lda [pstr], y
			vram_write_a()
			inc_16(pstr)
			dex
		} while(not zero)
		vram_clear_address()
		inc paddr
		dec sizeX
	} while(not zero)

	assign(PPU.CNT0, #0)
	vram_set_address_i(ATTRIBUTE_TABLE_0_ADDRESS)
	vram_fill(#00, #64)
	vram_clear_address()
}*/

byte X_OFFS[] = {lo(screan_line) + 5, lo(screan_line) + 4, lo(screan_line) + 1, lo(screan_line)}

inline vram_write_screen_line(addr) {
	assign(temp[0], #3)
	do {
		ldy temp[0]
		ldx X_OFFS, y

		ldy #L_SCREEN_HEIGHT
		vram_set_address(addr)
		do {
			lda screan_line, x
			vram_write_a()
			lda screan_line+2, x
			vram_write_a()
			txa
			clc
			adc #8
			tax
			dey
			dey
		} while(not zero)
		vram_clear_address()
		inc addr
		dec temp[0]
	} while(not minus)
}

function init_horiz_level() {
	assign(PPU.CNT0, #CR_ADDRINC32) // Vertical vram addressing
	assign_16i(plevel, level_data)
	assign_16i(im_addr, NAME_TABLE_0_ADDRESS)

	assign(temp[2], #(L_SCREEN_WIDTH / 4))
	do {
		init_sreen_line()
		
		vram_write_screen_line(im_addr)
		
		dec temp[2]
	} while(not zero)

	assign(PPU.CNT0, #0)
	vram_set_address_i(ATTRIBUTE_TABLE_0_ADDRESS)
	vram_fill(#00, #64)
	vram_clear_address()
}

inline start_game() {
	engine_init()
	
	forever() {
		read_port0()

		test_joystick1(#BUTTON_RIGHT)
		if (nonzero)
			inc scroll_X

		test_joystick1(#BUTTON_LEFT)
		if (nonzero)
			dec scroll_X

		vblank_wait()
		vram_set_scroll(scroll_X, scroll_Y)
	}
}