// ArtSoft corp.

enum rabbit {
	tile = 1,
	width = 5,
	height = 9
}


inline create_meta_sprite_inl(start_tile,x,y,width,height,attr) {
	assign(sprAttr, attr)
	assign(xOffs, x)
	assign(yOffs, y)
	assign(sizeX, width)
	assign(sizeY, height)
	assign(counter, start_tile)
	create_meta_sprite()
}

inline set_sprite_data_y(x, y, tile, attr) {
	assign_y(sprites,Y)
	iny
	assign_y(sprites,tile)
	iny
	assign_y(sprites,attr)
	iny
	assign_y(sprites,x)
	iny
}

// Start sprite number must be in Y
function create_meta_sprite() {
	do {
		assign(temp, xOffs)
		ldx sizeX
		do {
			set_sprite_data_y(temp, yOffs, counter, sprAttr)
			inc counter
			lda temp
			clc
			adc #8
			sta temp
			dex
		} while(not zero)
		lda yOffs
		clc
		adc #8
		sta yOffs
		dec sizeY
	} while(not zero)
}

inline meta_add_x_inl(start_tile,size,x) {
	assign(xOffs, x)
	assign(yOffs, #3)
	assign(sizeX, size)
	assign(counter, start_tile)
	meta_add()
}

inline meta_add_y_inl(start_tile,size,x) {
	assign(xOffs, x)
	assign(sizeX, size)
	assign(yOffs, #0)
	assign(counter, start_tile)
	meta_add_x()
}

function meta_add() {
	lda counter
	asl A
	asl A
	clc
	adc yOffs
	tax
	ldy sizeX
	do {
		lda sprites,x
		clc
		adc xOffs
		if (carry) {
			lda #0
			cmp yOffs
			if (zero)
				sta sprites+1,x
			else
				sta sprites-2,x
		} else
			sta sprites,x
		inx
		inx
		inx
		inx
		dey
	} while (not zero)
}

inline meta_set_tile_inl(start_tile,size,new_tile) {
	assign(xOffs, new_tile)
	assign(sizeX, size)
	assign(counter, start_tile)
	meta_add_x()
}

function meta_set_tile() {
	lda counter
	asl A
	asl A
	clc
	adc 1
	tax
	lda xOffs
	ldy sizeX
	do {
		sta sprites,x
		clc
		adc 1
		inx
		inx
		inx
		inx
		dey
	} while (not zero)
}