// ArtSoft corp.

#define IM_WIDTH 30
#define IM_HEIGHT 8

inline vram_write_block_inl(addr)
{
    assign_16i(pstr, addr)
	vram_draw_block()
}

function vram_draw_block()
{
	lda #0
	sta counter
	ldy #IM_HEIGHT
	do {
		vram_set_address(pstr)
		ldx #IM_WIDTH
		do {
			inc counter
			lda counter
			vram_write_a()
			dex
		} while(not zero)
		add_16_8(pstr, #NAMETABLE_WIDTH)
		vram_clear_address()
		dey
	} while(not zero)
}

byte game_name[] = {S_LEFT,S_N,S_A,S_Z,S_V,S_A,S_N,S_I,S_E, S_SPACE, S_I,S_G,S_R,S_bI,S_RIGHT, 0}
byte game_author[] = {S_A,S_V,S_T,S_O,S_R, S_SPACE, S_EQUAL, S_SPACE, S_S,S_V,S_YA,S_T,S_O,S_H,S_A, S_SPACE, S_A,S_R,S_T,S_E,S_M, S_COPY, 0}
byte game_year[] = {S_G,S_O,S_D, S_SPACE, S_2,S_K,S_1,S_6, 0}

byte press_start[] = {S_N,S_A,S_J,S_M,S_I,S_T,S_E, S_SPACE, S_S,S_T,S_A,S_R,S_T, 0}

byte players_1[] = {S_RIGHT, S_SPACE, S_1, S_SPACE, S_I,S_G,S_R,S_O,S_K, 0}
byte players_2[] = {S_2, S_SPACE, S_I,S_G,S_R,S_O,S_K,S_A, 0}

inline draw_start_screan() {
	vram_write_string_inl(NAME_TABLE_0_ADDRESS + (6*NAMETABLE_WIDTH+9), game_name)
	vram_write_string_inl(NAME_TABLE_0_ADDRESS + (26*NAMETABLE_WIDTH+6), game_author)
	vram_write_string_inl(NAME_TABLE_0_ADDRESS + (27*NAMETABLE_WIDTH+6), game_year)
	
	vram_write_string_inl(NAME_TABLE_0_ADDRESS + (19*NAMETABLE_WIDTH+10), press_start)
	
	vram_write_string_inl(p1_addr, players_1)
	vram_write_string_inl(NAME_TABLE_0_ADDRESS + (22*NAMETABLE_WIDTH+12), players_2)
	//vram_write_block_inl(NAME_TABLE_1_ADDRESS + (8*32+1))
	ldy #0
	create_meta_sprite_inl(#rabbit.tile, #0, #52, #rabbit.width, #rabbit.height, #%00000000)
	//vram_write_image_inl(NAME_TABLE_0_ADDRESS + (8*32+1), ArtSoft, ArtSoft_i.w, ArtSoft_i.h)
	
	vram_set_address_i(ATTRIBUTE_TABLE_0_ADDRESS)
	vram_fill(#0x55, #16)
	vram_fill(#0x00, #16)
	vram_fill(#0x55, #32)
	vram_clear_address()
}

inline ram_prepeat() {
	assign_16_16(pstr, im_addr)
	ldy #0
	ldx #0
	do {
		lda [pstr, x]
		sta temp, y
		add_16_8(pstr, #ArtSoft_i.w)
		iny
		cpy #ArtSoft_i.h
	} while (not equal)
	inc_16(im_addr)
	inc paddr
}

inline start_screan_cycle() {
	assign_16i(paddr, NAME_TABLE_0_ADDRESS + (8*NAMETABLE_WIDTH+0))
	assign_16i(im_addr, ArtSoft)
	forever {
		meta_add_x_inl(#0, #(rabbit.width * rabbit.height), #4)
		lda (sprites[0] + 3) // X coord
		cmp #252
		if (equal)
			jmp end_cycle
		cmp #240
		if (not carry) {
			and #7
			cmp #4
			sec
			if (equal) {
				ram_prepeat()
				ldx #0
				clc
			}
		}

		vblank_wait()
		if (not carry) {
			vram_set_address(paddr)
			do {
				lda temp, x
				vram_write_a()
				inx
				cpx #ArtSoft_i.h
			} while (not equal)
			vram_clear_address()
		}
		vram_sprite_dma_copy(sprites)
	}
end_cycle:
	vblank_wait()
	assign(PPU.CNT1, #CR_BACKVISIBLE|CR_BACKNOCLIP)
	vram_clear_address()
	unvblank_wait()
	
	ldy #16
	ldx #0
	do {
		vblank_wait()
		tya
		and #3
		if (zero) {
			vram_set_address_i(PAL_0_ADDRESS + 7)
			txa
			vram_write_a()
			clc
			adc #0x10
			tax
			vram_clear_address()
		}
		dey
	} while (not zero)
	
	selection_stage()
}

#define p1_addr NAME_TABLE_0_ADDRESS + (21*NAMETABLE_WIDTH+10)

inline selection_stage() {
	assign(temp, #0)
	forever {
		read_port0()
		test_buttons_press(#BUTTON_A|BUTTON_B|BUTTON_START|BUTTON_SELECT)
		if (not zero) {
			lda temp
			if (zero)
				jmp game_start
		}

		test_buttons_press(#BUTTON_DOWN|BUTTON_UP)
		if (not zero) {
			lda #1
			eor temp
			sta temp
		}
		
		vblank_wait()
		
		vram_set_address_i(p1_addr)
		lda temp
		if (zero) {
			vram_write(#S_RIGHT)
			vram_write(#S_SPACE)
		} else {
			vram_write(#S_SPACE)
			vram_write(#S_RIGHT)
		}
		vram_clear_address()
		
	}
game_start:
}
